import { OpenStoriesFeed } from 'openstories-types';
declare class OpenStoriesElement extends HTMLElement {
    root: ShadowRoot;
    dialog: HTMLDialogElement;
    button: HTMLButtonElement;
    close: HTMLButtonElement;
    time: HTMLElement;
    metadataDetails: HTMLElement;
    moreMetadata: HTMLButtonElement;
    meta: HTMLElement;
    openHeart: HTMLButtonElement;
    toggleMute: HTMLButtonElement;
    share: HTMLButtonElement;
    themeColor: HTMLMetaElement | null;
    link: HTMLAnchorElement;
    currentIndex: number;
    count: number;
    timer: number | null;
    currentBar: HTMLElement | null;
    currentStory: HTMLImageElement | HTMLVideoElement | null;
    stories: Array<HTMLImageElement | HTMLVideoElement>;
    bars: HTMLElement[];
    promises: Promise<unknown>[];
    paused: boolean;
    open: boolean;
    goToBinding: () => void;
    items: OpenStoriesFeed["items"];
    _src: string;
    _duration: number;
    constructor();
    get isHighlight(): boolean;
    setThemeColor(force: boolean): void;
    connectedCallback(): void;
    set src(path: string);
    get src(): string;
    set duration(value: number);
    get duration(): number;
    sendHeart(): Promise<void>;
    bindEvents(): void;
    itemByHash(): OpenStoriesFeed["items"][0] | undefined;
    checkHashId(): boolean;
    checkIfAllRead(): boolean;
    fetchData(url: string): Promise<void>;
    /**
     * Format a path to a valid URL.
     * @param path - The path to format.
     * @returns - The formatted path.
     */
    formatSrc(path: string | null): string;
    setIndexToUnread(): false | undefined;
    pause(): void;
    resume(): void;
    appendStories(): void;
    startTimer(): Promise<void>;
    goTo(delta?: number | null): Promise<void>;
    get viewedKey(): string;
    get lazyLoad(): boolean;
    setViewed(id: string): void;
    getViewedId(): any;
    prepareHeart(): void;
    relativeTime(time: string | undefined): string;
    handleRejection(promise: Promise<any>): Promise<void>;
    playStory(story: HTMLImageElement | HTMLVideoElement | null): void;
}
export default OpenStoriesElement;
declare global {
    interface Window {
        OpenStoriesElement: typeof OpenStoriesElement;
    }
    interface HTMLElementTagNameMap {
        'open-stories': OpenStoriesElement;
    }
}
